//in case of updates, change this value to the desired year, e.g. 2050
var sYear = "2020";

//webpage title that appears in the tab namespace
document.title = "IPA English charts";

//main webpage header (at the top)
var sMTitle = "IPA charts and sub-charts in four fonts";

//"main font header", "tooltip" on mouse over font name, "link", "short font name" used in filenames >>>please be certain when modifying it that it reflects your file naming convention<<<
var aFonts = [["IPA Kiel / LS Uni (serif)", "Linguist&rsquo;s Software page", "https://www.linguistsoftware.com/", "Kiel"], 
				["Doulos SIL (serif)", "SIL: Doulos SIL page", "https://software.sil.org/doulos/", "Doulos"], 
				["DejaVu Sans (sans serif)", "DejaVu fonts page", "https://dejavu-fonts.github.io/", "DejaVu"], 
				["Unitipa (TeX TIPA Roman)", "CTAN: Package tipa page", "https://ctan.org/pkg/tipa", "unitipa"]
];

//"chart type header", ["short chart type name" >>>please be certain... etc. - see above<<<, "file extension" >>>this must be the last item, since later on we have a function that adds full stop to the extension, so that when filename fragments are concatenated, we don't need to worry about it<<<]
//chart resolutions: numbers can be modified, but they must remain in the same place, e.g. you can change [1200, 600, 300] to [1000, 800, 600, 400, 200]
var aChTypes = [["Full chart"], 
				["Individual charts", [300, 600, 1200], "Please follow one of the SVG file links to display the chart section. Images can be downloaded in the PNG format with the following pre-set resolutions:", "or, <i>if supported by your browser</i>, a custom resolution selected on a slider (<i>after the slider has been clicked, keyboard arrows can be used to fine-tune the desired resolution</i>)"], 
				["List of symbols and diacritics with descriptions &amp; identifiers", "symbollist", "pdf"],
				["IPA number charts", "number_chart", "Cells contain numbers assigned to IPA symbols, not the symbols themselves.", "pdf"]
];

//"file type", "short file type name" >>>please be certain... etc. - see above<<<, "file extension" >>>this must be the last item... etc. - see above<<<
var aFileTypes = [["PDF (plain)", "full", "pdf"], 
				["PDF (with tooltips)", "tooltips", "pdf"], 
				["SVG (image)", "full", [612,792], "svg"]
];

//"chart subtype, i.e. individual table", "short chart subtype" name >>>please be certain... etc. - see above<<<
//IMPORTANT: the array below and the full svg dimensions from the array aFileTypes are repeated as array aDims in the Illutrator script - if you want to modify these values (in pixels), you'll have to do it in both files!
var aChSubtypes = [["pulmonic consonant", "CP", [506,213]], 
				["non-pulmonic consonant", "CnP", [280,164]], 
				["other symbols", "OS", [307,137]], 
				["diacritics", "D", [350,269]], 
				["vowel", "V", [241,197]], 
				["suprasegmentals", "S", [174,194]], 
				["tones and word accents", "T", [152,163]]
];
