var uri;

async function TestFirst() {
	if (isFirefox == false) {
		for (var f=-1;f<aRes.length;f++) {
			nR = 1;
			if (f > -1) {
				nR = aRes[f]/72;
			}
			var bCont = await GetPNG(nWRes,nHRes,nR);
			if (bCont == false) {
				bAlt = true;
				UpdateBr();
			}
			else if (bCont == true) {
				bAlt = false;
				UpdateBr();
			}
		}
	}
}
TestFirst();

function ResClick(nRes,nCh) {
	nWRes = 612;
	nHRes = 792;
	if (nCh > -1 & nCh < 99) {
		nWRes = aChSubtypes[nCh][2][0];
		nHRes = aChSubtypes[nCh][2][1];
	}
	nR = nRes/72;
	(async function(){
		var bResp = await GetPNG(nWRes,nHRes,nR);
		if (bResp == true) {
			UpdateCustom("(selected resolution)",nRes);
			SaveImg(nRes,true);
		}
		else {
			if (document.getElementById("slider_cont").style.display == "none") {
				ShowHideSlider();
			}
			if (document.getElementById("slRes").max < 1200) {
				nRes = document.getElementById("slRes").max;
				nR = nRes/72;
				(async function(){
					bResp = await GetPNG(nWRes,nHRes,nR);
					if (bResp == true) {
						UpdateCustom("(selected resolution)",nRes);
					}
					else {
						TestRes(bResp,nRes,nWRes,nHRes);
					}
				})();
			}
			else if (document.getElementById("slRes").max == 1200 && bResp == false) {
				TestRes(bResp,nRes,nWRes,nHRes);
			}
		}
	})();
}

function TestRes(bRespTemp,nResT,nWResT,nHResT) {
	var r = confirm("This image exceeds file size and/or file dimensions supported by your browser!\n\nWould you like to determine the maximum supported size and save the file? Resolution will be lower than your selected " + nResT + " pixels/inch.");
	if (r == true) {
		var bResp2;
		(async function(){
			do {
				nResT-=1;
				if (bResp2 == undefined) {
					document.getElementById("img_res").innerHTML = "<i>Please be patient.</i>";
				}
				else {
					UpdateCustom("(testing resolutions)",nResT);
				}
				nR = nResT/72;
				bResp2 = await GetPNG(nWResT,nHResT,nR);
			}
			while (bResp2 == false);
			document.getElementById("slRes").max = nResT;
			document.getElementById("max_res").innerHTML = nResT + " pixels/inch";
			UpdateCustom("(max resolution)",nResT);
		})();
	}
	else {
		UpdateCustom("(operation cancelled)",nResT);
	}
}

function GetPNG(nWTemp,nHTemp,nRTemp) {
	return new Promise(function(resolve) {
		if (nWTemp > 0 && nHTemp > 0 && nRTemp > 0) {
			document.getElementById("svg_scale").innerHTML = "<svg enable-background='new 0 0 " + nWTemp + " " + nHTemp + "' version='1.1' viewBox='0 0 " + nWTemp + " " + nHTemp + "' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' xml:space='preserve' width='" + nWTemp*nRTemp + "' height='" + nHTemp*nRTemp + "' id='svg-container'>" + sSVG + "</svg>";
			document.getElementById("canvas_cont").innerHTML = "<canvas id='canvas' width='" + nWTemp*nRTemp + "' height='" + nHTemp*nRTemp + "'></canvas>";
			var canvas = document.getElementById("canvas");
			canvas.style = 'display: none';
			var x = document.getElementById("svg_scale");
			var svg = x.querySelector("svg");
			var data = new XMLSerializer().serializeToString(svg);
			svg.style = 'display: none';
			var win = window.URL || window.webkitURL || window;
			var img = new Image();
			var blob = new Blob([data], {type: "image/svg+xml;charset=utf-8"});
			var url = win.createObjectURL(blob);
			img.onload = function() {
				canvas.getContext('2d', {alpha:false}).drawImage(img, 0, 0);
				win.revokeObjectURL(url);
				if (nFmtSel > -1 && nFmtSel < 3) {
					uri = canvas.toDataURL('image/'+aFmt[nFmtSel][0],aFmt[nFmtSel][2]).replace('image/'+aFmt[nFmtSel][0],'octet/stream');
				}
				else {
					uri = canvas.toDataURL('image/'+aFmt[nFmtSel]).replace('image/'+aFmt[nFmtSel],'octet/stream');
				}
				var head = 'data:octet/stream;base64,';
				var imgFileSize = Math.round((uri.length - head.length)*3/4) ;
				if (imgFileSize > 0) {
					resolve(true);
				}
				else {
					resolve(false);
				}
			}
			img.src = url;
		}
		else {
			resolve(false);
		}
	});
}
